import gym
import wandb
import panda_gym
import stable_baselines3
from stable_baselines3 import A2C
import matplotlib.pyplot as plt 

# start a new wandb run to track this script
wandb.init(project='Model2',   
    config={
    "Algorithm": "A2C",
    "env": "CartPole-v1",
    "episodes": 500,
    })
#define the environment
env = gym.make('PandaReachJointsDense-v2')
model = stable_baselines3.A2C('MultiInputPolicy', env, verbose=1)

scores=[]
for i in range(100):
    model.learn(total_timesteps=1000)
    obs = env.reset()
    rewards=0
    while True:
        action, _states = model.predict(obs)
        obs, reward, done, info = env.step(action)
        rewards+=reward
        env.render()
        if done:
            break
    scores.append(rewards)
    wandb.log({"rewards" : scores})
        

wandb.join()
model.save("PandaReach")

plt.plot(scores)
plt.xlabel("Episode")
plt.ylabel("Total Reward")
plt.show()
